///////////////////
// CAiManager.cpp

#include "stdafx.h"
#include "CAiManager.h"
#include "CAiBomber.h"
#include "COptions.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CAiManager::CAiManager (void)
{
    for (int Player = 0 ; Player < MAX_PLAYERS ; Player++)
        m_pBombers[Player] = NULL;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CAiManager::~CAiManager (void)
{
    Destroy();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CAiManager::Create (COptions* pOptions)
{
    for (int Player = 0 ; Player < MAX_PLAYERS ; Player++)
    {
        if (pOptions->GetBomberType(Player) == BOMBERTYPE_COM)
        {
            m_pBombers[Player] = new CAiBomber;
            m_pBombers[Player]->SetArena(&m_Arena);
            m_pBombers[Player]->Create(Player);
        }
    }

    m_Arena.Create();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CAiManager::Destroy (void)
{
    m_Arena.Destroy();

    for (int Player = 0 ; Player < MAX_PLAYERS ; Player++)
    {
        if (m_pBombers[Player] != NULL)
        {
            delete m_pBombers[Player];
            m_pBombers[Player] = NULL;
        }
    }
}


//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CAiManager::Update (float DeltaTime)
{
    m_Arena.Update(DeltaTime);

    for (int Player = 0 ; Player < MAX_PLAYERS ; Player++)
        if (m_pBombers[Player] != NULL)
            m_pBombers[Player]->Update(DeltaTime);
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
