/////////////////
// CAiManager.h

#ifndef __CAIMANAGER_H__
#define __CAIMANAGER_H__

#include "CAiArena.h"

class CArena;
class COptions;
class CAiBomber;

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

class CAiManager
{
private:

    CAiBomber*      m_pBombers [MAX_PLAYERS];
    CAiArena        m_Arena;
                                                        
public:                                                 
                                                        
                    CAiManager (void);
    virtual         ~CAiManager (void);
    inline void     SetArena (CArena* pArena);
    void            Create (COptions* pOptions);
    void            Destroy (void);
    void            Update (float DeltaTime);
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

inline void CAiManager::SetArena (CArena* pArena)
{
    ASSERT(pArena != NULL);
    m_Arena.SetArena(pArena);
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#endif
