//////////////////////
// CCommandChunk.cpp

#include "stdafx.h"
#include "CCommandChunk.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CCommandChunk::CCommandChunk (void)
{
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CCommandChunk::~CCommandChunk (void)
{
    
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CCommandChunk::Create (void)
{
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CCommandChunk::Destroy (void)
{
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CCommandChunk::Reset (void)
{
    m_NumberOfSteps = 0;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CCommandChunk::Store (EBomberMove BomberMove, EBomberAction BomberAction, float DeltaTime)
{
    // If there is no step yet
    if (m_NumberOfSteps == 0)
    {
        // Create first step
        m_Steps[0].BomberMove = BomberMove;
        m_Steps[0].BomberAction = BomberAction;
        m_Steps[0].Duration = DeltaTime;

        m_NumberOfSteps++;
    }
    // If there is already at least one step
    else
    {
        // If the latest step has a different move or action than the ones we have to add
        if (m_Steps[m_NumberOfSteps - 1].BomberMove != BomberMove ||
            m_Steps[m_NumberOfSteps - 1].BomberAction != BomberAction)
        {
            ASSERT(m_NumberOfSteps < MAX_STEPS_IN_COMMAND_CHUNK);

            if (m_NumberOfSteps < MAX_STEPS_IN_COMMAND_CHUNK)
            {            
                // This is a new step
                m_Steps[m_NumberOfSteps].BomberMove = BomberMove;
                m_Steps[m_NumberOfSteps].BomberAction = BomberAction;
                m_Steps[m_NumberOfSteps].Duration = DeltaTime;

                m_NumberOfSteps++;
            }
        }
        // If the move and action did not change since latest step
        else
        {
            // Use latest step, increase duration
            m_Steps[m_NumberOfSteps - 1].Duration += DeltaTime;
        }
    }
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
    