////////////////////
// CCommandChunk.h

#ifndef __CCOMMANDCHUNK_H__
#define __CCOMMANDCHUNK_H__

#include "CBomber.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#define MAX_STEPS_IN_COMMAND_CHUNK      8

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

struct SCommandStep
{
    EBomberMove BomberMove;
    EBomberAction BomberAction;
    float Duration;
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

class CCommandChunk
{
private:

    SCommandStep            m_Steps [MAX_STEPS_IN_COMMAND_CHUNK];
    int                     m_NumberOfSteps;
                                                        
public:                                                 
                                                        
                            CCommandChunk (void);               //!< Constructor.
    virtual                 ~CCommandChunk (void);              //!< Destructor.
    void                    Create (void);                      //!< 
    void                    Destroy (void);                     //!< 
    void                    Reset (void);                       //!< 
    void                    Store (EBomberMove BomberMove, EBomberAction BomberAction, float DeltaTime);
    inline EBomberMove      GetStepMove (int Step);
    inline EBomberAction    GetStepAction (int Step);
    inline float            GetStepDuration (int Step);
    inline int              GetNumberOfSteps (void);
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

inline EBomberMove CCommandChunk::GetStepMove (int Step)
{
    ASSERT(Step >= 0);
    ASSERT(Step < m_NumberOfSteps);
    return m_Steps[Step].BomberMove;
}

inline EBomberAction CCommandChunk::GetStepAction (int Step)
{
    ASSERT(Step >= 0);
    ASSERT(Step < m_NumberOfSteps);
    return m_Steps[Step].BomberAction;
}

inline float CCommandChunk::GetStepDuration (int Step)
{
    ASSERT(Step >= 0);
    ASSERT(Step < m_NumberOfSteps);
    return m_Steps[Step].Duration;
}

inline int CCommandChunk::GetNumberOfSteps (void)
{
    return m_NumberOfSteps;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#endif
