///////////////////
// CElement.cpp

#include "stdafx.h"
#include "CElement.h"
#include "CArenaSnapshot.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CElement::CElement (void)
{
    m_Exist = false;
    m_pDisplay = NULL;
    m_pSound = NULL;
    m_pArena = NULL;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CElement::~CElement (void)
{
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CElement::Create (void)
{
    m_Exist = true;
    ASSERT (m_pArena != NULL);
    ASSERT (m_pDisplay != NULL);
    ASSERT (m_pSound != NULL);
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CElement::Destroy (void)
{
    m_Exist = false;
    m_pDisplay = NULL;
    m_pSound = NULL;
    m_pArena = NULL;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CElement::WriteSnapshot (CArenaSnapshot& Snapshot)
{
    Snapshot.WriteBoolean(m_Exist);

    if (m_Exist)
        OnWriteSnapshot(Snapshot);
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CElement::ReadSnapshot (CArenaSnapshot& Snapshot)
{
    Snapshot.ReadBoolean(&m_Exist);

    if (m_Exist)
        OnReadSnapshot(Snapshot);
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
