/////////////////////////////////////////
// CLog.cpp
//
// by Thibaut "Fury" Tollemer
// 
// Most of the code was taken in the
// Log.cpp/Log.h files of HaCKeR source,
// by Michal Schoonbrood :
//      - MadButch@OneCoolDude.Com
//      - http://play.as/madbutch
//

#ifndef _LOG_H
#define _LOG_H

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#include <fstream.h>
#include <iostream.h>

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#define theLog  CLog::GetLog()

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

class CLog
{
public:
                    CLog();
    virtual         ~CLog();
    static CLog&    GetLog();                               //!< Get an instance of CLog (singleton)
    bool            Open( const char *pFilename );          //!< Open the log
    bool            Close();                                //!< Close the log
    void            LogLastError();                         //!< Log the last occured error!
    long            Write ( const char *pMessage, ... );
    long            WriteLine( const char *pMessage, ... ); //!< Write a line to the log
    inline bool     IsOpen();                               //!< Return weather the log is open or not

private:

    ofstream        m_theLog;
    bool            m_bOpen;
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

// Return weather the log is open or not
inline bool CLog::IsOpen()
{
    return m_bOpen;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#endif // _LOG_H
