/////////////////////////
// CMenuMatch.h

#ifndef __CMENUMATCH_H__
#define __CMENUMATCH_H__

#include "CMenuBase.h"

enum EMenuAction;

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#define MENUMATCH_OPTIONS_COUNT     3

enum EMatchOption
{
    OPTION_BATTLE,
    OPTION_TIME,
    OPTION_TIMEUP,
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

class CMenuMatch : public CMenuBase
{
private:

    EMatchOption    m_Options [MENUMATCH_OPTIONS_COUNT];    //!< Options of this menu in the right order
    int             m_CursorOption;                         //!< Option the cursor hand is currently pointing to

    void            OnCreate (void);
    void            OnDestroy (void);
    void            OnUp (void);
    void            OnDown (void);
    void            OnLeft (void);
    void            OnRight (void);
    void            OnPrevious (void);
    void            OnNext (void);
    void            OnUpdate (void);
    void            OnDisplay (void);

public:

    CMenuMatch (void);
    virtual ~CMenuMatch (void);
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#endif // __CMENUMATCH_H__