///////////////////
// CModeScreen.cpp

#include "stdafx.h"
#include "CModeScreen.h"
#include "CDisplay.h"
#include "CInput.h"
#include "COptions.h"
#include "CGame.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#define BLACKSCREEN_DURATION                    0.750f  // Duration (in seconds) of each of the two black screens
                                                
//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CModeScreen::CModeScreen ()
{
    // Initialize the pointers to NULL so that we 
    // can easily detect the ones we forgot to set.
    m_pDisplay = NULL;
    m_pInput = NULL;
    m_pOptions = NULL;
    m_pTimer = NULL;
    m_pSound = NULL;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CModeScreen::~CModeScreen (void)
{
    // Nothing to do!
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CModeScreen::Create (void)
{
    // Check if all the objects to communicate with are set
    ASSERT (m_pDisplay != NULL);
    ASSERT (m_pInput != NULL);
    ASSERT (m_pOptions != NULL);
    ASSERT (m_pTimer != NULL);
    ASSERT (m_pSound != NULL);
    
    OpenInput ();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CModeScreen::Destroy (void)
{
    CloseInput ();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
