/////////////////////////
// CPauseMessage.h

#ifndef __CPAUSEMESSAGE_H__
#define __CPAUSEMESSAGE_H__

class CDisplay;
class CSound;

#include "CScroller.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

class CPauseMessage
{
private:

    CScroller   m_Scroller;
    CDisplay*   m_pDisplay;
    CSound*     m_pSound;
    bool        m_Waiting;
    bool        m_HaveToGetOut;

public:

                CPauseMessage (CDisplay* pDisplay, CSound* pSound);
                ~CPauseMessage (void);
    void        Update (float DeltaTime);
    void        Display (void);
    inline bool IsWaiting (void);
    void        GetOut (void);
    inline bool IsOutOfBounds (void);
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

inline bool CPauseMessage::IsWaiting (void)
{
    return m_Waiting;
}

inline bool CPauseMessage::IsOutOfBounds (void)
{
    return m_Scroller.OutOfBounds ();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

#endif // __CPAUSEMESSAGE_H__