/////////////////////////
// CRandomMosaic.cpp

#include "stdafx.h"
#include "CRandomMosaic.h"
#include "CMosaic.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

SMosaicTileProperties CRandomMosaic::m_MosaicTileProperties [3][3] =
{
    {
        { 46, 0, 5, 9, 64, 32 },
        { 47, 0, 4, 9, 82, 41 },
        { 48, 0, 4, 9, 82, 41 }
    },
    
    {
        { 19, 0, 5, 9, 64, 32 },
        { 51, 0, 4, 9, 82, 41 },
        { 52, 0, 4, 9, 82, 41 }
    },
    
    {
        { 29, 0, 5, 9, 64, 32 },
        { 49, 0, 4, 9, 82, 41 },
        { 50, 0, 4, 9, 82, 41 }
    }
};

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CMosaic* CRandomMosaic::CreateRandomMosaic (CDisplay* pDisplay, 
                                            int SpriteLayer, 
                                            int PriorityInLayer, 
                                            float SpeedX, 
                                            float SpeedY, 
                                            EMosaicColor Color)
{
    SMosaicTileProperties* pMosaicTileProperties = &m_MosaicTileProperties[(int)Color][RANDOM(3)];    

    CMosaic* pNewMosaic = new CMosaic;
    
    pNewMosaic->SetDisplay (pDisplay);
    pNewMosaic->Create (pMosaicTileProperties->SpriteTable, 
                        pMosaicTileProperties->Sprite, 
                        SpriteLayer, 
                        PriorityInLayer, 
                        pMosaicTileProperties->Width, 
                        pMosaicTileProperties->Height, 
                        pMosaicTileProperties->CountX, 
                        pMosaicTileProperties->CountY, 
                        SpeedX,
                        SpeedY);

    return pNewMosaic;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
