///////////////////
// CScores.cpp

#include "stdafx.h"
#include "CScores.h"
#include "COptions.h"

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CScores::CScores (void)
{
    // Initialize the pointers to NULL so that we 
    // can easily detect the ones we forgot to set.
    m_pOptions = NULL;
    
    Reset();
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

CScores::~CScores (void)
{
    // Nothing to do
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CScores::Reset (void)
{   
    // Reset player scores
    for (int Player = 0 ; Player < MAX_PLAYERS ; Player++)
    {
        m_Scores[Player] = 0;
    }

    // Reset draw games count
    m_DrawGamesCount = 0;
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CScores::RaisePlayerScore (int Player)
{
    // If maximum has not been reached
    if (m_Scores[Player] < m_pOptions->GetBattleCount())
    {
        // Increase score
        m_Scores[Player]++;
    }
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************

void CScores::RaiseDrawGamesCount (void)
{
    // If maximum has not been reached
    if (m_DrawGamesCount < MAX_DRAWGAME_SCORE)
    {
        // Increase count
        m_DrawGamesCount++;
    }
}

//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
